#include "Player.h"

using namespace std;

Player::Player()
{
	pLoc = mStart;
}


void Player::Move(string direction)
{
	if (direction == "north")
	{
		if (pLoc->pNorth->GetName() != "Nothing")
		{
			pLoc = pLoc->pNorth;
		}
		else
		{
			cout << "That's not gonna work. Find a better plan." << endl;
		}
	}
	else if (direction == "south")
	{
		if (pLoc->pSouth->GetName() != "Nothing")
		{
			pLoc = pLoc->pSouth;
		}
		else
		{
			cout << "That's not gonna work. Find a better plan." << endl;
		}
	}
	else if (direction == "east")
	{
		if (pLoc->pEast->GetName() != "Nothing")
		{
			pLoc = pLoc->pEast;
		}
		else
		{
			cout << "That's not gonna work. Find a better plan." << endl;
		}
	}
	else if (direction == "west")
	{
		if (pLoc->pWest->GetName() != "Nothing")
		{
			pLoc = pLoc->pWest;
		}
		else
		{
			cout << "That's not gonna work. Find a better plan." << endl;
		}
	}
	else
	{
		cout << "That's not a valid direction. try using north,south,east,west" << endl;
	}
}

void Player::Look(string direction, vector<string>vec)
{
	if (direction == "north")
	{
		pLoc->pNorth->pRoomName(inventory);
	}
	else if (direction == "south")
	{
		pLoc->pSouth->pRoomName(inventory);
	}
	else if (direction == "east")
	{
		pLoc->pEast->pRoomName(inventory);
	}
	else if (direction == "west")
	{
		pLoc->pWest->pRoomName(inventory);
	}
	else if (direction == "here")
	{
		int j = 0;
		while (j != vec.size())
		{
			cout << vec[j] << endl;
			j++;
		}
	}
	else
	{
		cout << "That's not a valid direction. try using north,south,east,west or here" << endl;
	}
}

void Player::Show()
{
	int j = 0;
	while (j != inventory.size())
	{
		cout << inventory[j] << endl;
		j++;
	}
}

void Player::Give(string g)
{
	inventory.push_back(g);
	cout << "you got " << g << endl;
}

void Player::pickup(string i)
{
	int j = 0;
	while (j != inventory.size())
	{
		if (inventory[j] == i)
		{
			cout << "Cant pick up what I already have" << endl;
			return;
		}
		j++;
	}
	j = 0;
	while (j != pLoc->inventory.size())
	{
		if (i == pLoc->inventory[j])
		{
			inventory.push_back(i);
			cout << "you got " << i << endl;
			return;
		}
		j++;
	}
	cout << "I can't find that so I can't pick it up" << endl;
}