#include "Room.h"


//using namespace std;


Room::Room(string n, string desc)
{
	rName = n;
	rDesc = desc;
}

string Room::GetName()
{
	return rName;
}

void Room::pRoomName(vector<string>vec)
{
	if (rName == "Battlefield" && part2 == false)
	{
		cout << rName << endl;
		bool check = find("ale", vec);
		if (check == true)
		{
			cout << "Due to your intoxication you fell down and passed out away from the battle. As you wake up you notice there's not a soul around" << endl;
			part2 = true;
			return;
		}
		else if (check == false)
		{
			cout << "After arriving you realize you don't know how to fight and end up costing your army the war." << endl;
			gameover = true;
			return;
		}
	}
	if (rName == "Enemy Dungeon")
	{
		if (captured == true)
		{
			bool check = find("charm", vec);
			if (check == true)
			{
				cout << "The old man you met earlier helps you escape your chains." << endl;
				captured = false;
				return;
			}
			else if (check == false)
			{
				cout << "Your mistake cost you your life as you're left to rot in the dungeon.";
				gameover = true;
				return;
			}
		}

	}
	cout << rName << endl;
}

bool Room::find(string o, vector<string>vec)
{
	int j = 0;
	while (j != vec.size())
	{
		if (o == vec[j])
		{
			return true;
		}
		j++;
	}
	return false;
}

int Room::talk(vector<string> pv)
{
	if (people[0] == "villager")
	{
		cout << "G'day fellow.";
	}
	else if (people[0] == "shopkeeper")
	{
		cout << "Hey there, I don't got any items for sale right now. Check back later";
	}
	else if (people[0] == "bartender")
	{
		bool check = find("gear", pv);
		if (check == false)
		{
			cout << "Listen, I know you dont got coin for a drink. Get out" << endl;
		}
		else if (check == true)
		{
			cout << "This one's on the house" << endl;
			return 3;
		}
	}
	else if (people[0] == "resident")
	{
		cout << "I can't believe whats going on.";
	}
	else if (people[0] == "guard")
	{
		cout << "Get out of here.";
	}
	else if (people[0] == "king")
	{
		bool check = find("note", pv);
		if (check == false)
		{
			cout << "These are times of war, no man can be wasted. Take this and talk to the soldier in the armory." << endl;
			return 1;
		}
		else if (check == true)
		{
			cout << "Now that you have a note you should pay a visit to the soldier in the armory" << endl;
		}
		check = find("meat", pv);
		if (check == true)
		{
			cout << "If their supplies are poisoned then we should strike now." << endl;
			return 10;
		}

	}
	else if (people[0] == "soldier")
	{
		bool check = find("gear", pv);
		if (check == false)
		{
			bool check = find("note", pv);
			if (check == false)
			{
				cout << "Get lost!";
			}
			else if (check == true)
			{
				cout << "Take this and head east past the forest to the battlefield.";
				return 2;
			}
		}
		else if (check == true)
		{
			cout << "Might need a drink before you head out";
		}
	}
	else if (people[0] == "stranger")
	{
		cout << "You dont look familiar. You shouldn't be here.";
	}
	else if (people[0] == "owner")
	{
		bool check = find("clothes", pv);
		if (check == false)
		{
			cout << "I dont got much but I cant let you walk around looking like that. Take these" << endl;
			return 4;
		}
		if (check == true)
		{
			cout << "Now you look less like a stranger.";
		}

	}
	else if (people[0] == "footman")
	{
		bool check = find("equipment", pv);
		if (check == false)
		{
			cout << "You're not allowed here.";
			return 6;
		}
		else if (check == true)
		{
			check = find("meat", pv);
			if (check == false)
			{
				cout << "I hate this kingdom, I wish the whole thing would just get wiped off the map" << endl;
				check = find("rabbit", pv);
				if (check == false)
				{
					cout << "Can you bring me some food and some poison?";
				}
				else if (check == true)
				{
					check = find("nightshade", pv);
					if (check == false)
					{
						cout << "You're missing a key ingredient here. Go check the forest again";
					}
					else if (check == true)
					{
						cout << "Alright that should ruin most of the food supply. You should go tell the other king. Dont forget to take some proof" << endl;
						return 9;
					}
				}
			}
			else if (check == true)
			{
				cout << "Go tell your king what happened";
			}
		}

	}
	else if (people[0] == "knight")
	{
		bool check = find("equipment", pv);
		if (check == false)
		{
			check = find("letter", pv);
			if (check == true)
			{
				cout << "Take this gear. We need you to be useful later.";
				return 7;
			}
			else if (check == false)
			{
				cout << "You dont have any business here.";
			}
		}
		else if (check == true)
		{
			cout << "Go find something to do until we need you" << endl;
		}

	}
	else if (people[0] == "lord")
	{
		bool check = find("letter", pv);
		if (check == false)
		{
			check = find("clothes", pv);
			if (check == true)
			{
				cout << "You there, take this note and bring it to the knight at the armory. Another battle is coming soon and I need every able body i can get" << endl;
				return 5;
			}
			else if (check == false)
			{
				cout << "It's not often a prisoner of war comes to me directly." << endl;
				return 6;
			}
		}
		else if (check == true)
		{
			cout << "I said go to the armory" << endl;
		}
	}
	else if (people[0] == "old man")
	{
		cout << "How did you find this place? I haven't had a guest in years. All i can offer you is this good luck charm.";
		return 8;
	}
	else if (people[0] == "barkeep")
	{
		bool check = find("clothes", pv);
		if (check == false)
		{
			cout << "Sorry but I don't have business for you";
		}
		else if (check == true)
		{
			cout << "We're closed until the war is over";
		}
	}
	else
	{
		cout << "I cant talk to dust and ghosts";
	}
	cout << endl;
	return 0;
}

void Room::pRoomDesc()
{
	cout << rDesc << endl;
}
