#include "Map.h"

using namespace std;

Map::~Map()
{
	delete mStart->pNorth;
	delete mStart->pEast;
	delete mStart->pSouth;
	delete mStart->pWest;
}

Map::Map()
{

	Room* p1 = new Room("Home", "Looks the same as I left it");
	mStart = p1;
	Room* p2 = new Room("Town Square", "The center of a quiet town although there is a villager here so it can't be too quiet");
	Room* p3 = new Room("Store", "Nothing here except for the counter and the shopkeeper");
	Room* p4 = new Room("Tavern", "The second most cared for building in town. It's always busy here. I should talk to the bartender");
	Room* p5 = new Room("Castle", "The courtyard alone is bigger than the whole town. There's a castle resident here.");
	Room* p6 = new Room("Barracks", "Looks like your average bedroom stretched to fit too many people. There's a friendly looking guard.");
	Room* p7 = new Room("Throne Room", "A fancy room so large the emptiness is almost suffocating. The king's sitting in his throne at the back.");
	Room* p8 = new Room("Armory", "Swords, swords, swords, you'd think these guys would appreciate a little variety. There's a soldier here");
	Room* p9 = new Room("Forest", "Somehow less quiet than the town");
	Room* p10 = new Room("Battlefield", "Not a pleasant place to loiter unless you like the dead");
	Room* p11 = new Room("Desert", "An ocean of sand. You expect anyone to be here?");
	Room* p12 = new Room("Enemy Town", "Looks like my town but more menacing. There's even a menacing stranger here");
	Room* p13 = new Room("Enemy Store", "Well it's bigger than my store but thats not saying much. The owner's behind the counter");
	Room* p14 = new Room("Enemy Tavern", "Looks run down so I guess I should appreciate what I got. Maybe the barkeep has something to say");
	Room* p15 = new Room("Enemy Castle", "Like a zen garden but instead of rocks there's huge stone buildings");
	Room* p16 = new Room("Enemy Barracks", "Looks a little familiar, there's even a footman here. I can just feel the nostalgia");
	Room* p17 = new Room("Enemy Armory", "At least these guys use axes. The knight here might be able to help me");
	Room* p18 = new Room("Enemy Throne Room", "If satan was an interior designer this room would be his magnum opus. Maybe the lord here is friendly");
	Room* p19 = new Room("Old House", "The interior is the definition of cozy. The old man here must be the owner");
	Room* p20 = new Room("Enemy Dungeon", "Dank and depressing. There's not much else to say");
	Room* p0 = new Room("Nothing", "It's empty");
	Holder = p20;

	p1->pNorth = p2;
	p1->pEast = p0;
	p1->pSouth = p0;
	p1->pWest = p0;
	p1->inventory.push_back("mail");


	p2->pNorth = p5;
	p2->pEast = p4;
	p2->pSouth = p1;
	p2->pWest = p3;
	p2->people.push_back("villager");

	p3->pNorth = p0;
	p3->pEast = p2;
	p3->pSouth = p0;
	p3->pWest = p0;
	p3->people.push_back("shopkeeper");

	p4->pNorth = p0;
	p4->pEast = p0;
	p4->pSouth = p0;
	p4->pWest = p2;
	p4->people.push_back("bartender");

	p5->pNorth = p7;
	p5->pEast = p8;
	p5->pSouth = p2;
	p5->pWest = p6;
	p5->people.push_back("resident");

	p6->pNorth = p0;
	p6->pEast = p5;
	p6->pSouth = p0;
	p6->pWest = p0;
	p6->people.push_back("guard");

	p7->pNorth = p0;
	p7->pEast = p0;
	p7->pSouth = p5;
	p7->pWest = p0;
	p7->people.push_back("king");

	p8->pNorth = p0;
	p8->pEast = p9;
	p8->pSouth = p0;
	p8->pWest = p5;
	p8->people.push_back("soldier");

	p9->pNorth = p0;
	p9->pEast = p10;
	p9->pSouth = p19;
	p9->pWest = p8;
	p9->inventory.push_back("rabbit");
	p9->inventory.push_back("nightshade");

	p10->pNorth = p0;
	p10->pEast = p11;
	p10->pSouth = p0;
	p10->pWest = p9;

	p11->pNorth = p12;
	p11->pEast = p0;
	p11->pSouth = p0;
	p11->pWest = p10;

	p12->pNorth = p15;
	p12->pEast = p13;
	p12->pSouth = p11;
	p12->pWest = p14;
	p12->people.push_back("stranger");

	p13->pNorth = p0;
	p13->pEast = p0;
	p13->pSouth = p0;
	p13->pWest = p12;
	p13->people.push_back("owner");

	p14->pNorth = p0;
	p14->pEast = p12;
	p14->pSouth = p0;
	p14->pWest = p0;
	p14->people.push_back("barkeep");

	p15->pNorth = p18;
	p15->pEast = p16;
	p15->pSouth = p12;
	p15->pWest = p17;

	p16->pNorth = p20;
	p16->pEast = p0;
	p16->pSouth = p0;
	p16->pWest = p15;
	p16->people.push_back("footman");

	p17->pNorth = p0;
	p17->pEast = p15;
	p17->pSouth = p0;
	p17->pWest = p0;
	p17->people.push_back("knight");

	p18->pNorth = p0;
	p18->pEast = p20;
	p18->pSouth = p15;
	p18->pWest = p0;
	p18->people.push_back("lord");

	p19->pNorth = p9;
	p19->pEast = p0;
	p19->pSouth = p0;
	p19->pWest = p0;
	p19->people.push_back("old man");

	p20->pNorth = p0;
	p20->pEast = p0;
	p20->pSouth = p16;
	p20->pWest = p18;
}